<?php 

/**
 * @file
 * Provide views data and handlers for presentation.module
 */



/**
 * Implementation of hook_views_data()
 */
function presentation_views_data() {

  $data['presentation_presentations']['table']['group'] = t('Presentation'); 
  $data['presentation_presentations']['table']['join'] = array(
    'node' => array(
      'left_field' => 'nid',
      'field' => 'nid',
      'type' => 'INNER',
    ),
  );
    
  $data['presentation_presentations']['path'] = array(
    'title' => t('Presentation Thumbnail'),
    'help' => t('The first picture in the presentation. A placeholder will be shown if the presentation is empty.'),
    'field' => array(
      'handler' => 'views_handler_field_presentation',
    ),
  
  );
  
  return $data;


}








/**
 * Implementation of hook_views_handlers() to register all of the basic handlers
 * presentation uses.
 */
function presentation_views_handlers() {
  return array(
    'info' => array(
    ),
    'handlers' => array(
      // field handlers
      'views_handler_field_presentation' => array(
        'parent' => 'views_handler_field',
      ),
    ),
  );
}








/*


function presentation_views_tables() {
  $tables['presentation'] = array(
    'name' => 'presentation',
    'fields' => array(
      'presentation' => array(
        'name' => t('presentation: presentation Thumbnail'),
        'handler' => array(
          'presentation_views_handler_presentation' => t('Image'),
        ),
        'option' => array(
          '#type' => 'select',
          '#options' => 'presentation_views_sizes',
        ),
        'notafield' => true,
        'sortable' => false,
      ),
    ),
  );
  return $tables;
}






function presentation_views_sizes() {
  $sizes = presentation_sizes();
  $content = array();
  
  foreach ($sizes as $key => $size) {
    $content[$key] = $size['label'];
  }
  
  return $content;
}


*/

/**
 * Views handler for displaying the image.
 */ /*
function presentation_views_handler_presentation($fieldinfo, $fielddata, $value, $data) {
  $node = node_load($data->nid);
  
  presentation_load_style();
  
  return theme('presentation_presentations_grid', $node, $fielddata['options']);
}

*/



/**
 * Theme the grid containing all presentations.
 *
 */
function theme_views_view_presentation_grid($view, $type, $nodes, $level = NULL, $args = NULL) {
  $output = '';
  $output .= '<div class="presentation-grid-view">';
  
  presentation_load_style();
  presentation_load_js();

  foreach($nodes as $node) {
    $output .= theme('presentation_presentations_grid', $node);
  }
  
  $output .= '</div>';
  
  return $output;
}




/**
 * Themes each thumbnail to be displayed by the default view.
 *
 */
function theme_presentation_presentations_grid($node, $size = 'thumbnail') {

  presentation_load_js();
  
  $node = node_load($node->nid);
  $translucent = variable_get('presentation_translucence', 1) ? ' translucent' : '';
  
  if ($node->presentation['default']) {
    $default = presentation_load_picture($node->presentation['default']);
    $thumbnail = theme('image', $default->$size, '', $node->title, array('class' => 'presentation-external-thumbnail' . $translucent));
  
  }

  $link =  l($thumbnail, 'node/' . $node->nid, array('attributes' => array('class' => 'presentation-external-picture-link'), 'html' => TRUE));
  
  $output .= $link;

  return $output;
}

